<?php
/**
 * @package n3tComingSoon
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.filesystem.file' );
jimport('joomla.version');

class plgSystemN3tComingSoon extends JPlugin
{

	function plgSystemN3tComingSoon(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}
  
  public function onAfterInitialise()   
  {
    $app =& JFactory::getApplication(); 
    if ($app->isSite()) {
      $can_display = false;
      
      $online = $this->params->def('online', '');
      $get_filter = trim($this->params->def('get_filter', ''));
      $ip_filter = trim($this->params->def('ip_filter', ''));
            
      if ($online) {        
        $date_online =& JFactory::getDate($online);
        $date_now =& JFactory::getDate('now');
        if (JVersion::isCompatible('1.6.0')) {  
          $date_now->setTimeZone(new DateTimeZone($app->getCfg('offset')));
          $unix_now = $date_now->toUnix();
          $unix_now += $date_now->getOffsetFromGMT();            
        } else {
          $date_now->setOffset($app->getCfg('offset'));
          $unix_now = $date_now->toUnix(true);
        }          
        if ($date_online->toUnix() <= $unix_now) 
        { 
      	  $db =& JFactory::getDBO();  	  
          if (JVersion::isCompatible('1.6.0')) {
            $db->setQuery('UPDATE #__extensions SET enabled=0 WHERE type="plugin" AND element="n3tcomingsoon" AND folder="system"');
          } else {
            $db->setQuery('UPDATE #__plugins SET published=0 WHERE element="n3tcomingsoon" AND folder="system"');
          }	 
          $db->query();     
          $can_display = true;
        } else {
          $seconds_online = $date_online->toUnix() - $unix_now;          
          $date_online = $date_online->toFormat($this->params->def('date_format', '%Y-%m-%d %H:%M'));
        }
      } else {
        $seconds_online = 0;
        $date_online = false;
      }      
      if (!$can_display && $get_filter) {
        $can_display = $app->getUserStateFromRequest( $this->_name.".get_filter", $get_filter, '' );
      }
      if (!$can_display && $ip_filter) {
        $ip_filter = preg_split('/\s*\n\s*/', $ip_filter);
        $can_display = array_search($_SERVER['REMOTE_ADDR'], $ip_filter) !== false;
      }
      if (!$can_display) {
        $custom_file = $this->params->def('custom_file', '');
                
  	    JResponse::setHeader('Content-Type', 'text/html; charset=utf-8');
        JResponse::sendHeaders();        

        $this->loadLanguage('', JPATH_ADMINISTRATOR);
   
        $theme = $this->params->def('theme', 'light');
        $logo = $this->params->def('logo', '');
        $title = $this->params->def('title', $app->getCfg('sitename'));
        $text = $this->params->def('text', JText::_('PLG_SYSTEM_N3TCOMINGSOON_COMING_SOON'));          
        $meta_desc = $this->params->def('meta_desc', $app->getCfg('MetaDesc'));
        $meta_keys = $this->params->def('meta_keys', $app->getCfg('MetaKeys'));
        
        if ($custom_file && JFile::exists(JPATH_BASE.DS.$custom_file)) {
          require(JPATH_BASE.DS.$custom_file);
        } else {                  
          require(JPATH_BASE.DS.'media'.DS.'plg_n3tcomingsoon'.DS.'soon.php');
        }
        $app->close();
      }
    }
  }	
}